---
policy: /ce/unit-test/is-equal/date-time
logic: /ce/unit-test/is-equal/date-time/unit-test.logic.yaml
executionTime: 2025-04-24T23:48:00.386896298Z
rows:
  - id: Test-1
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: "unitTest(Test-1): '2000-01-01T00:00:00Z' == '2000-01-01T00:00:00Z'"
      actual: "unitTest(Test-1): '2000-01-01T00:00:00Z' == '2000-01-01T00:00:00Z'"
    runtimeError: {}
  - id: Test-2
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 299
      actual: 299
    conditionText:
      expected: "unitTest(Test-2): '2000-01-01T00:00:00Z' == '2000-01-01T01:00:00+01:00'"
      actual: "unitTest(Test-2): '2000-01-01T00:00:00Z' == '2000-01-01T01:00:00+01:00'"
    runtimeError: {}
  - id: Test-3
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 399
      actual: 399
    conditionText:
      expected: "unitTest(Test-3): '2000-01-01T00:00:00Z' != '2000-01-01T00:00:00.001Z'"
      actual: "unitTest(Test-3): '2000-01-01T00:00:00Z' != '2000-01-01T00:00:00.001Z'"
    runtimeError: {}
  - id: Test-4
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 499
      actual: 499
    conditionText:
      expected: "unitTest(Test-4): '1970-01-01T00:00:00Z' != null"
      actual: "unitTest(Test-4): '1970-01-01T00:00:00Z' != null"
    runtimeError: {}
  - id: Test-5
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 599
      actual: 599
    conditionText:
      expected: "unitTest(Test-5): null == null"
      actual: "unitTest(Test-5): null == null"
    runtimeError: {}
usedFiles:
  - path: /ce/unit-test/is-equal/date-time/policy.yaml
    md5Hash: 8CD30A76E4AEEB2A5ADA96F98616BB34
    content: |-
      ---
      names:
        full: "IS_EQUAL / NOT_EQUAL Unit Tests: DateTimeType"
        contextual: "DateTimeType"
      description: ""
  - path: /ce/unit-test/is-equal/date-time/unit-test.logic.yaml
    md5Hash: 0A138AF9A6DDFD11CBEB7150C212C2CB
    content: |-
      ---
      inputType: CA10__CaAwsInstance__c
      testData:
        - file: test-data.json
      conditions:
        - status: COMPLIANT
          currentStateMessage: Test-1
          check:
            UNIT_TEST:
              id: Test-1
              arg:
                IS_EQUAL:
                  left:
                    DATE_TIME: "2000-01-01T00:00:00Z"
                  right:
                    DATE_TIME: "2000-01-01T00:00:00Z"
        - status: COMPLIANT
          currentStateMessage: Test-2
          check:
            UNIT_TEST:
              id: Test-2
              arg:
                IS_EQUAL:
                  left:
                    DATE_TIME: "2000-01-01T00:00:00Z"
                  right:
                    DATE_TIME: "2000-01-01T01:00:00+01:00"
        - status: COMPLIANT
          currentStateMessage: Test-3
          check:
            UNIT_TEST:
              id: Test-3
              arg:
                NOT_EQUAL:
                  left:
                    DATE_TIME: "2000-01-01T00:00:00Z"
                  right:
                    DATE_TIME: "2000-01-01T00:00:00.001Z"
        - status: COMPLIANT
          currentStateMessage: Test-4
          check:
            UNIT_TEST:
              id: Test-4
              arg:
                NOT_EQUAL:
                  left:
                    DATE_TIME: "1970-01-01T00:00:00Z"
                  right:
                    UNIT_TEST_NULL:
                      returnType: DATE_TIME
        - status: COMPLIANT
          currentStateMessage: Test-5
          check:
            UNIT_TEST:
              id: Test-5
              arg:
                IS_EQUAL:
                  left:
                    UNIT_TEST_NULL:
                      returnType: DATE_TIME
                  right:
                    UNIT_TEST_NULL:
                      returnType: DATE_TIME
      otherwise:
        status: INCOMPLIANT
        currentStateMessage: Test Failed
        remediationMessage: Developer Fix Required
  - path: /ce/unit-test/is-equal/date-time/test-data.json
    md5Hash: 83D48AFD6CE722624C6CF80DE9FBC66F
    content: |-
      [
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "199",
            "conditionText": "unitTest(Test-1): '2000-01-01T00:00:00Z' == '2000-01-01T00:00:00Z'",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2024-01-01T00:00:00Z"
          },
          "Id": "Test-1",
          "Name": "Test-1",
          "CA10__disappearanceTime__c": null
        },
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "299",
            "conditionText": "unitTest(Test-2): '2000-01-01T00:00:00Z' == '2000-01-01T01:00:00+01:00'",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2024-01-01T00:00:00Z"
          },
          "Id": "Test-2",
          "Name": "Test-2",
          "CA10__disappearanceTime__c": null
        },
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "399",
            "conditionText": "unitTest(Test-3): '2000-01-01T00:00:00Z' != '2000-01-01T00:00:00.001Z'",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2024-01-01T00:00:00Z"
          },
          "Id": "Test-3",
          "Name": "Test-3",
          "CA10__disappearanceTime__c": null
        },
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "499",
            "conditionText": "unitTest(Test-4): '1970-01-01T00:00:00Z' != null",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2024-01-01T00:00:00Z"
          },
          "Id": "Test-4",
          "Name": "Test-4",
          "CA10__disappearanceTime__c": null
        },
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "599",
            "conditionText": "unitTest(Test-5): null == null",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2024-01-01T00:00:00Z"
          },
          "Id": "Test-5",
          "Name": "Test-5",
          "CA10__disappearanceTime__c": null
        }
      ]
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "Test-1",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "199",
      "conditionText" : "unitTest(Test-1): '2000-01-01T00:00:00Z' == '2000-01-01T00:00:00Z'",
      "runtimeError" : null
    }
  }, {
    "Id" : "Test-2",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "299",
      "conditionText" : "unitTest(Test-2): '2000-01-01T00:00:00Z' == '2000-01-01T01:00:00+01:00'",
      "runtimeError" : null
    }
  }, {
    "Id" : "Test-3",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "399",
      "conditionText" : "unitTest(Test-3): '2000-01-01T00:00:00Z' != '2000-01-01T00:00:00.001Z'",
      "runtimeError" : null
    }
  }, {
    "Id" : "Test-4",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "499",
      "conditionText" : "unitTest(Test-4): '1970-01-01T00:00:00Z' != null",
      "runtimeError" : null
    }
  }, {
    "Id" : "Test-5",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "599",
      "conditionText" : "unitTest(Test-5): null == null",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAwsInstance__c()
  RETURNS ARRAY<STRUCT<
      Id STRING,
      CA10__disappearanceTime__c TIMESTAMP,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2024-01-01T00:00:00Z")
    },
    "Id" : "Test-1"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-01-01T00:00:00Z")
    },
    "Id" : "Test-2"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-01-01T00:00:00Z")
    },
    "Id" : "Test-3"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-01-01T00:00:00Z")
    },
    "Id" : "Test-4"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-01-01T00:00:00Z")
    },
    "Id" : "Test-5"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAwsInstance__c(
      obj STRUCT<
          Id STRING,
          CA10__disappearanceTime__c TIMESTAMP
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
      var TemporalLib = new function () {
          var iso8601regex = /^([\+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24\:?00)([\.,]\d+(?!:))?)?(\17[0-5]\d([\.,]\d+)?)?([zZ]|([\+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/
          this.checkIso8601 = function(arg) {
              return arg == null || iso8601regex.test(arg);
          };
          this.parseIso8601 = function(arg) {
              return new Date(arg);
          };
          this.replaceNullValues = function(arg, nullValues) {
              for (var i = 0; i < nullValues.length; i++) {
                  if (TextLib.equal(arg, nullValues[i])) {
                      return null;
                  }
              }
              return arg;
          };
      }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From AWS [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function dateTimeEqual2() {
          var equalLeft3 = TemporalLib.parseIso8601('2000-01-01T00:00:00Z');
          var equalRight4 = TemporalLib.parseIso8601('2000-01-01T00:00:00Z');
          return (equalLeft3 == null && equalRight4 == null) || (equalLeft3 != null && equalRight4 != null && equalLeft3.getTime() == equalRight4.getTime());
      }
      try {
          if (obj.Id == 'Test-1' && dateTimeEqual2()) {
              return {status: 'COMPLIANT', conditionIndex: 199, conditionText: "unitTest(Test-1): '2000-01-01T00:00:00Z' == '2000-01-01T00:00:00Z'", currentStateMessage: "Test-1", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[2], conditionIndex:[200..299]
      function dateTimeEqual5() {
          var equalLeft6 = TemporalLib.parseIso8601('2000-01-01T00:00:00Z');
          var equalRight7 = TemporalLib.parseIso8601('2000-01-01T01:00:00+01:00');
          return (equalLeft6 == null && equalRight7 == null) || (equalLeft6 != null && equalRight7 != null && equalLeft6.getTime() == equalRight7.getTime());
      }
      try {
          if (obj.Id == 'Test-2' && dateTimeEqual5()) {
              return {status: 'COMPLIANT', conditionIndex: 299, conditionText: "unitTest(Test-2): '2000-01-01T00:00:00Z' == '2000-01-01T01:00:00+01:00'", currentStateMessage: "Test-2", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[3], conditionIndex:[300..399]
      function dateTimeEqual8() {
          var equalLeft9 = TemporalLib.parseIso8601('2000-01-01T00:00:00Z');
          var equalRight10 = TemporalLib.parseIso8601('2000-01-01T00:00:00.001Z');
          return !(equalLeft9 == null && equalRight10 == null) && !(equalLeft9 != null && equalRight10 != null && equalLeft9.getTime() == equalRight10.getTime());
      }
      try {
          if (obj.Id == 'Test-3' && dateTimeEqual8()) {
              return {status: 'COMPLIANT', conditionIndex: 399, conditionText: "unitTest(Test-3): '2000-01-01T00:00:00Z' != '2000-01-01T00:00:00.001Z'", currentStateMessage: "Test-3", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[4], conditionIndex:[400..499]
      function dateTimeEqual11() {
          var equalLeft12 = TemporalLib.parseIso8601('1970-01-01T00:00:00Z');
          return !(equalLeft12 == null && null == null) && !(equalLeft12 != null && null != null && equalLeft12.getTime() == null.getTime());
      }
      try {
          if (obj.Id == 'Test-4' && dateTimeEqual11()) {
              return {status: 'COMPLIANT', conditionIndex: 499, conditionText: "unitTest(Test-4): '1970-01-01T00:00:00Z' != null", currentStateMessage: "Test-4", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[5], conditionIndex:[500..599]
      if (obj.Id == 'Test-5' && ((null == null && null == null) || (null != null && null != null && null.getTime() == null.getTime()))) {
          return {status: 'COMPLIANT', conditionIndex: 599, conditionText: "unitTest(Test-5): null == null", currentStateMessage: "Test-5", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      return {status: 'INCOMPLIANT', conditionIndex: 600, conditionText: "otherwise", currentStateMessage: "Test Failed", currentStateReferences: references1.join('\n'), remediation: "Developer Fix Required", runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.Id AS Id,
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          process_CA10__CaAwsInstance__c(
              STRUCT(
                  sObject.Id AS Id,
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAwsInstance__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
